
#ifndef _H_MCUTIL_COLLEC_GEN_VEC
#define _H_MCUTIL_COLLEC_GEN_VEC

#include "mcutil.h"
#include <stddef.h>

#define MCU_GEN_VEC_INITIAL_SIZE 32

typedef struct gen_vec_s {
    void** inner;
    size_t count;
    size_t capacity;
} gen_vec_t;

MCU_API void  mcu_gen_vec_insert_front(gen_vec_t* gv, void* data);
MCU_API void  mcu_gen_vec_insert_back(gen_vec_t* gv, void* data);
MCU_API void* mcu_gen_vec_remove_back(gen_vec_t *gv);
MCU_API void* mcu_gen_vec_remove_front(gen_vec_t *gv);

#endif
